"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var angular_1 = require("@radzen/angular");
var Component_1 = require("./Component");
var env = require("./env");
function dynamicComponentFactory(template, compiler, properties) {
    if (properties === void 0) { properties = {}; }
    var DynamicComponent = (function () {
        function DynamicComponent() {
            Object.assign(this, properties);
        }
        return DynamicComponent;
    }());
    DynamicComponent = __decorate([
        core_1.Component({
            template: template
        }),
        __metadata("design:paramtypes", [])
    ], DynamicComponent);
    var DynamicModule = (function () {
        function DynamicModule() {
        }
        return DynamicModule;
    }());
    DynamicModule = __decorate([
        core_1.NgModule({
            imports: [
                common_1.CommonModule,
                angular_1.RadzenModule
            ],
            declarations: [
                DynamicComponent
            ]
        })
    ], DynamicModule);
    return compiler.compileModuleAndAllComponentsSync(DynamicModule)
        .componentFactories.find(function (factory) { return factory.componentType === DynamicComponent; });
}
function renderComponent(properties) {
    return env.renderComponent(Component_1.parseComponent(properties));
}
var AppComponent = (function () {
    function AppComponent(changeDetector, compiler, resolver, elementRef) {
        this.changeDetector = changeDetector;
        this.compiler = compiler;
        this.resolver = resolver;
        this.elementRef = elementRef;
    }
    AppComponent.prototype.unloadComponent = function (element) {
        if (element) {
            var ref = element.ref;
            if (ref) {
                ref.destroy(); // destroy removes the element
            }
        }
    };
    AppComponent.prototype.updateComponent = function (properties, data, container) {
        var element = container.firstChild;
        var template = renderComponent(properties);
        var componentFactory = dynamicComponentFactory(template, this.compiler, Object.assign({}, properties, data, {
            components: [
                properties
            ]
        }));
        var ref = this.containerRef.createComponent(componentFactory);
        container.replaceChild(ref.location.nativeElement, container.firstChild);
        ref.location.nativeElement.ref = ref;
        this.changeDetector.detectChanges();
        element.ref.destroy();
    };
    AppComponent.prototype.loadComponent = function (type, properties, data, container) {
        var template = renderComponent(properties);
        var componentFactory = dynamicComponentFactory(template, this.compiler, Object.assign({}, properties, data, {
            components: [
                properties
            ]
        }));
        var ref = this.containerRef.createComponent(componentFactory);
        container.appendChild(ref.location.nativeElement);
        ref.location.nativeElement.ref = ref;
        this.changeDetector.detectChanges();
    };
    return AppComponent;
}());
__decorate([
    core_1.ViewChild('container', { read: core_1.ViewContainerRef }),
    __metadata("design:type", core_1.ViewContainerRef)
], AppComponent.prototype, "containerRef", void 0);
AppComponent = __decorate([
    core_1.Component({
        selector: 'radzen-app',
        template: '<div #container></div>'
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef,
        core_1.Compiler,
        core_1.ComponentFactoryResolver,
        core_1.ElementRef])
], AppComponent);
exports.AppComponent = AppComponent;
//# sourceMappingURL=AppComponent.js.map