export interface Response {
}
export interface Parameter {
    in?: string;
    name?: string;
    type?: string;
    required?: boolean;
}
export interface Operation {
    name: string;
    method: string;
    parameters: Array<Parameter>;
    responses: Array<Response>;
}
export interface Resource {
    path: string;
    operations: Array<Operation>;
}
export interface Authorization {
    type: string;
    clientId: string;
    url: string;
    scopes: Array<string>;
}
export interface DataSource {
    authorization?: Authorization;
    resources: Array<Resource>;
    name: string;
    basePath: string;
    schemas: Array<Schema>;
    connector: string;
    type: string;
}
export interface Schema {
    name: string;
    table?: string;
    properties: Array<Property>;
}
export interface Property {
    name: string;
    properties?: Array<Property>;
    array?: boolean;
    key?: boolean;
    type: string;
}
export declare function swaggerToDataSource(swagger: any): DataSource;
