import { Application } from './Application';
export * from './toolbox';
export * from './bootstrap';
export * from './build';
export * from './securityDataSource';
export declare function styles(path: string, application: Application): Array<string>;
export declare function copyThemeDir(path: string, source: string, name: string): Promise<any>;
export declare function setConfigValue(path: string, key: string, value: string): Promise<any>;
export declare function getConfigValue(path: string, key: string): Promise<any>;
export declare function getConnectionString(path: string, key: string): Promise<any>;
export declare function setConnectionString(path: string, key: string, value: any): Promise<any>;
export declare function saveSSL(path: string, key: string, cert: string): Promise<any>;
export declare function generate(path: string, application: Application, isRunning?: boolean): Promise<any>;
export interface StartServerOptions {
    directory: string;
    onStart: (process: any) => void;
    onError: () => void;
    onExit: () => void;
    onSuccess: () => void;
}
export declare function startServer({directory, onStart, onError, onExit, onSuccess}: StartServerOptions): void;
export declare function supportsServer(): Promise<any>;
export declare function designTimeHtml(application: Application): Promise<string>;
export declare function setPageTitle(contentDocument: Document, title: string): void;
export declare function setLogo(contentDocument: Document, path: string, application: Application): void;
export declare function navigationContainerElement(contentDocument: Document): Element;
export declare function contentElements(contentDocument: Document): NodeListOf<Element>;
export declare function deleteDataSource(path: string, name: string): Promise<any>;
export declare function deletePage(path: string, name: string): Promise<any>;
export declare function renamePage(path: string, from: string, to: string): Promise<any>;
