"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function securityDataSource() {
    return {
        "swagger": "2.0",
        "info": {
            "title": "Security",
            "version": "1.0.0"
        },
        "produces": [],
        "host": null,
        "schemes": [
            "http"
        ],
        "basePath": null,
        "definitions": {
            "Error": {
                "type": "object",
                "properties": {
                    "error": {
                        "type": "object",
                        "properties": {
                            "message": {
                                "type": "string"
                            }
                        }
                    }
                }
            },
            "Role": {
                "type": "object",
                "properties": {
                    "id": {
                        "type": "string"
                    },
                    "name": {
                        "type": "string"
                    }
                }
            },
            "User": {
                "type": "object",
                "properties": {
                    "id": {
                        "type": "string"
                    },
                    "userName": {
                        "type": "string"
                    },
                    "email": {
                        "type": "string"
                    }
                }
            }
        },
        "paths": {
            "/auth/login": {
                "post": {
                    "operationId": "login",
                    "parameters": [
                        {
                            "in": "formData",
                            "name": "username",
                            "type": "string",
                            "required": true
                        },
                        {
                            "in": "formData",
                            "name": "password",
                            "type": "string",
                            "required": true
                        }
                    ],
                    "responses": {
                        "default": {
                            "description": "",
                            "schema": {
                                "$ref": "#/definitions/Error"
                            }
                        }
                    }
                }
            },
            "/auth/users": {
                "get": {
                    "operationId": "getUsers",
                    "responses": {
                        "200": {
                            "description": "",
                            "schema": {
                                "type": "array",
                                "items": {
                                    "$ref": "#/definitions/User"
                                }
                            }
                        }
                    }
                }
            },
            "/auth/register": {
                "post": {
                    "operationId": "registerUser",
                    "parameters": [
                        {
                            "in": "formData",
                            "name": "email",
                            "type": "string",
                            "required": true
                        },
                        {
                            "in": "formData",
                            "name": "password",
                            "type": "string",
                            "required": true
                        }
                    ],
                    "responses": {
                        "default": {
                            "description": "",
                            "schema": {
                                "$ref": "#/definitions/Error"
                            }
                        }
                    }
                }
            },
            "/auth/users/{id}": {
                "delete": {
                    "operationId": "deleteUser",
                    "parameters": [
                        {
                            "in": "path",
                            "name": "id",
                            "type": "string",
                            "required": true
                        }
                    ],
                    "responses": {
                        "204": {
                            "description": "",
                        }
                    }
                }
            },
            "/auth/roles": {
                "get": {
                    "operationId": "getRoles",
                    "responses": {
                        "200": {
                            "description": "",
                            "schema": {
                                "type": "array",
                                "items": {
                                    "$ref": "#/definitions/Role"
                                }
                            }
                        }
                    }
                },
                "post": {
                    "operationId": "createRole",
                    "parameters": [
                        {
                            "in": "body",
                            "name": "Role",
                            "required": true,
                            "schema": {
                                "$ref": "#/definitions/Role"
                            }
                        }
                    ],
                    "responses": {
                        "201": {
                            "description": "",
                        }
                    }
                }
            },
            "/auth/roles/{id}": {
                "delete": {
                    "operationId": "deleteRole",
                    "parameters": [
                        {
                            "in": "path",
                            "name": "id",
                            "required": true,
                            "type": "string"
                        }
                    ],
                    "responses": {
                        "204": {
                            "description": "",
                        }
                    }
                }
            }
        }
    };
}
exports.securityDataSource = securityDataSource;
//# sourceMappingURL=securityDataSource.js.map