"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var login = {
    title: 'Login',
    type: 'object',
    icon: 'icon-login',
    properties: {
        type: {
            enum: ['login']
        },
        name: {
            type: 'string',
            default: ''
        },
        events: {
            type: 'object',
            properties: {
                login: {
                    type: 'array'
                },
                register: {
                    type: 'array'
                }
            }
        }
    },
    required: ['type', 'name']
};
var dropdown = {
    title: 'DropDown',
    type: 'object',
    icon: 'icon-dropdown',
    properties: {
        type: {
            enum: ['dropdown']
        },
        name: {
            type: 'string',
            default: ''
        },
        textProperty: {
            type: 'string',
            editor: 'dataSourceProperty'
        },
        value: {
            type: 'string',
            editor: 'data'
        },
        data: {
            type: 'string',
            editor: 'array'
        },
        placeholder: {
            type: 'string',
        },
        events: {
            type: 'object',
            properties: {
                change: {
                    type: 'array'
                }
            }
        }
    },
    required: ['type', 'name']
};
var button = {
    title: 'Button',
    type: 'object',
    icon: 'icon-button',
    properties: {
        type: {
            enum: ['button']
        },
        name: {
            type: 'string',
            default: ''
        },
        text: {
            type: 'string',
            editor: 'code',
            default: ''
        },
        buttonStyle: {
            enum: ['default', 'blue-grey', 'cyan', 'amber', 'teal', 'red', 'orange', 'green', 'deep-orange', 'purple', 'indigo', 'pink'],
            default: 'default'
        },
        events: {
            type: 'object',
            properties: {
                click: {
                    type: 'array'
                }
            }
        }
    },
    required: ['type', 'text', 'name']
};
var textbox = {
    title: 'TextBox',
    type: 'object',
    icon: 'icon-textbox',
    properties: {
        type: {
            enum: ['textbox']
        },
        name: {
            type: 'string',
            default: ''
        },
        value: {
            type: 'string',
            editor: 'code',
            default: ''
        },
        placeholder: {
            type: 'string',
            editor: 'code',
            default: ''
        },
        events: {
            type: 'object',
            properties: {
                change: {
                    type: 'array'
                }
            }
        }
    },
    required: ['type', 'value', 'name']
};
var grid = {
    title: 'DataGrid',
    type: 'object',
    icon: 'icon-grid',
    properties: {
        type: {
            enum: ['grid']
        },
        name: {
            type: 'string',
            default: ''
        },
        title: {
            type: 'string',
            default: ''
        },
        data: {
            type: 'string',
            default: '',
            editor: 'array'
        },
        allowDelete: {
            type: 'boolean'
        },
        allowAdd: {
            type: 'boolean'
        },
        allowSorting: {
            type: 'boolean'
        },
        allowMultiSorting: {
            type: 'boolean'
        },
        allowPaging: {
            type: 'boolean'
        },
        pageSize: {
            type: 'integer',
            default: 10
        },
        allowFiltering: {
            type: 'boolean'
        },
        allowScrolling: {
            type: 'boolean'
        },
        events: {
            type: 'object',
            properties: {
                select: {
                    type: 'array'
                },
                add: {
                    type: 'array'
                },
                delete: {
                    type: 'array'
                },
                loadData: {
                    type: 'array'
                }
            }
        },
        columns: {
            type: 'array',
            editor: 'columnsEditor',
            items: {
                type: 'object',
                properties: {
                    property: {
                        type: 'string',
                        editor: 'dataSourceProperty'
                    },
                    title: {
                        type: 'string'
                    },
                    template: {
                        type: 'string',
                        editor: 'code'
                    },
                    type: {
                        enum: [
                            'string',
                            'integer',
                            'number',
                            'boolean'
                        ],
                        default: 'string'
                    },
                    format: {
                        enum: [
                            '',
                            'int32',
                            'int64',
                            'float',
                            'double',
                            'byte',
                            'binary',
                            'date',
                            'date-time',
                            'password'
                        ]
                    }
                }
            }
        }
    },
    required: ['type', 'data', 'columns', 'name']
};
var form = {
    title: 'Form',
    type: 'object',
    icon: 'icon-form',
    properties: {
        type: {
            enum: ['form']
        },
        name: {
            type: 'string',
            default: ''
        },
        data: {
            type: 'string',
            default: '',
            editor: 'data'
        },
        title: {
            type: 'string',
            default: ''
        },
        submitText: {
            type: 'string',
            default: 'Save'
        },
        cancelText: {
            type: 'string',
            default: 'Cancel'
        },
        events: {
            type: 'object',
            properties: {
                submit: {
                    type: 'array'
                },
                cancel: {
                    type: 'array'
                }
            }
        },
        visible: {
            type: 'boolean',
            editor: 'code'
        },
        fields: {
            type: 'array',
            editor: 'fieldsEditor',
            items: {
                type: 'object',
                properties: {
                    property: {
                        type: 'string',
                        editor: 'dataSourceProperty'
                    },
                    textProperty: {
                        type: 'string',
                        editor: 'dataSourceProperty',
                        dataSource: 'data'
                    },
                    valueProperty: {
                        type: 'string',
                        editor: 'dataSourceProperty',
                        dataSource: 'data'
                    },
                    placeholder: {
                        type: 'string'
                    },
                    data: {
                        type: 'string',
                        editor: 'array'
                    },
                    required: {
                        type: 'boolean'
                    },
                    title: {
                        type: 'string'
                    },
                    type: {
                        enum: [
                            'string',
                            'integer',
                            'number',
                            'boolean'
                        ],
                        default: 'string'
                    },
                    format: {
                        enum: [
                            '',
                            'int32',
                            'int64',
                            'float',
                            'double',
                            'byte',
                            'binary',
                            'date',
                            'date-time',
                            'password'
                        ]
                    }
                }
            }
        }
    },
    required: ['type', 'data', 'name']
};
function chart(title, icon, type) {
    return {
        title: title,
        type: 'object',
        icon: icon,
        properties: {
            type: {
                enum: ['chart']
            },
            name: {
                type: 'string',
                default: ''
            },
            legend: {
                type: 'boolean',
                default: false
            },
            title: {
                type: 'string'
            },
            chartType: {
                enum: ['Column', 'Line', 'Bar', 'Area'],
                default: type
            },
            data: {
                type: 'string',
                default: '',
                editor: 'array'
            },
            valueProperty: {
                type: 'string',
                editor: 'dataSourceProperty'
            },
            categoryProperty: {
                type: 'string',
                editor: 'dataSourceProperty'
            },
            series: {
                type: 'string',
                editor: 'dataSourceProperty'
            }
        },
        required: ['type', 'data', 'chartType', 'legend', 'name']
    };
}
var html = {
    title: 'HTML',
    type: 'object',
    icon: 'icon-html',
    properties: {
        type: {
            enum: ['html']
        },
        name: {
            type: 'string',
            default: ''
        },
        content: {
            type: 'string',
            default: '',
            editor: 'code'
        }
    },
    required: ['type', 'content', 'name']
};
function pie(title, icon, type) {
    return {
        title: title,
        type: 'object',
        icon: icon,
        properties: {
            type: {
                enum: ['pie']
            },
            name: {
                type: 'string',
                default: ''
            },
            chartType: {
                enum: ['Pie', 'Donut'],
                default: type
            },
            data: {
                type: 'string',
                default: '',
                editor: 'array'
            },
            valueProperty: {
                type: 'string',
                editor: 'dataSourceProperty'
            },
            legend: {
                type: 'boolean',
                default: true
            },
            labels: {
                type: 'boolean',
                default: true
            },
            title: {
                type: 'string'
            },
            categoryProperty: {
                type: 'string',
                editor: 'dataSourceProperty'
            }
        },
        required: ['type', 'valueProperty', 'data', 'chartType', 'legend', 'name']
    };
}
function toolbox() {
    return [
        button,
        textbox,
        dropdown,
        chart('Area Chart', 'icon-area-chart', 'Area'),
        chart('Bar Chart', 'icon-bar-chart', 'Bar'),
        pie('Donut Chart', 'icon-donut-chart', 'Donut'),
        form,
        grid,
        html,
        chart('Line Chart', 'icon-line-chart', 'Line'),
        pie('Pie Chart', 'icon-pie-chart', 'Pie'),
        login
    ];
}
exports.toolbox = toolbox;
//# sourceMappingURL=toolbox.js.map