"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var TEXTBOX_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DatePickerComponent; }),
    multi: true
};
var DatePickerComponent = (function () {
    function DatePickerComponent() {
        this.placeholder = '';
        this.change = new core_1.EventEmitter();
        this.onChange = function (_) { };
        this.onTouched = function () { };
    }
    Object.defineProperty(DatePickerComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value != this.innerValue) {
                this.innerValue = value;
                this.onChange(value);
                this.change.next(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    DatePickerComponent.prototype.writeValue = function (value) {
        this.innerValue = value;
    };
    DatePickerComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    DatePickerComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    return DatePickerComponent;
}());
DatePickerComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'rz-datepicker',
                template: "\n    <p-calendar appendTo=\"body\"\n      class=\"form-control\"\n      [(ngModel)]=\"value\"\n      [placeholder]=\"placeholder\"\n      (onBlur)=\"onTouched()\">\n    </p-calendar>\n  ",
                providers: [TEXTBOX_VALUE_ACCESSOR]
            },] },
];
/** @nocollapse */
DatePickerComponent.ctorParameters = function () { return []; };
DatePickerComponent.propDecorators = {
    'value': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'change': [{ type: core_1.Output },],
};
exports.DatePickerComponent = DatePickerComponent;
