"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var primeng_1 = require("primeng/primeng");
var ngx_charts_1 = require("@swimlane/ngx-charts");
var gravatar_component_1 = require("./gravatar.component");
exports.GravatarComponent = gravatar_component_1.GravatarComponent;
var grid_component_1 = require("./grid.component");
exports.GridColumn = grid_component_1.GridColumn;
exports.GridComponent = grid_component_1.GridComponent;
var container_component_1 = require("./container.component");
var form_component_1 = require("./form.component");
exports.FormComponent = form_component_1.FormComponent;
var form_field_component_1 = require("./form-field.component");
exports.FormFieldComponent = form_field_component_1.FormFieldComponent;
var chart_component_1 = require("./chart.component");
exports.ChartComponent = chart_component_1.ChartComponent;
var pie_component_1 = require("./pie.component");
exports.PieComponent = pie_component_1.PieComponent;
var textbox_component_1 = require("./textbox.component");
exports.TextBoxComponent = textbox_component_1.TextBoxComponent;
var button_component_1 = require("./button.component");
exports.ButtonComponent = button_component_1.ButtonComponent;
var html_component_1 = require("./html.component");
exports.HtmlComponent = html_component_1.HtmlComponent;
var dropdown_component_1 = require("./dropdown.component");
exports.DropDownComponent = dropdown_component_1.DropDownComponent;
var notification_component_1 = require("./notification.component");
exports.NotificationComponent = notification_component_1.NotificationComponent;
var datepicker_component_1 = require("./datepicker.component");
exports.DatePickerComponent = datepicker_component_1.DatePickerComponent;
var login_component_1 = require("./login.component");
exports.LoginComponent = login_component_1.LoginComponent;
exports.COMPONENTS = [
    grid_component_1.GridComponent,
    grid_component_1.GridColumn,
    form_component_1.FormComponent,
    form_field_component_1.FormFieldComponent,
    chart_component_1.ChartComponent,
    pie_component_1.PieComponent,
    textbox_component_1.TextBoxComponent,
    html_component_1.HtmlComponent,
    notification_component_1.NotificationComponent,
    datepicker_component_1.DatePickerComponent,
    dropdown_component_1.DropDownComponent,
    button_component_1.ButtonComponent,
    gravatar_component_1.GravatarComponent,
    login_component_1.LoginComponent
];
var RadzenModule = (function () {
    function RadzenModule() {
    }
    return RadzenModule;
}());
RadzenModule.decorators = [
    { type: core_1.NgModule, args: [{
                imports: [
                    common_1.CommonModule,
                    forms_1.ReactiveFormsModule,
                    forms_1.FormsModule,
                    primeng_1.CheckboxModule,
                    primeng_1.TriStateCheckboxModule,
                    primeng_1.DropdownModule,
                    primeng_1.DataTableModule,
                    primeng_1.SpinnerModule,
                    primeng_1.GrowlModule,
                    primeng_1.CalendarModule,
                    primeng_1.DialogModule,
                    ngx_charts_1.NgxChartsModule,
                    primeng_1.PasswordModule,
                    primeng_1.SharedModule
                ],
                exports: [
                    exports.COMPONENTS,
                    forms_1.FormsModule,
                    primeng_1.DialogModule,
                    forms_1.ReactiveFormsModule
                ],
                declarations: [
                    container_component_1.ContainerComponent
                ].concat(exports.COMPONENTS)
            },] },
];
/** @nocollapse */
RadzenModule.ctorParameters = function () { return []; };
exports.RadzenModule = RadzenModule;
