"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var LoginComponent = (function () {
    function LoginComponent(formBuilder) {
        this.formBuilder = formBuilder;
        this.login = new core_1.EventEmitter();
        this.register = new core_1.EventEmitter();
    }
    LoginComponent.prototype.ngOnInit = function () {
        this.form = this.formBuilder.group({
            username: ['', forms_1.Validators.required],
            password: ['', forms_1.Validators.required]
        });
    };
    LoginComponent.prototype.onSubmit = function (event) {
        event.stopPropagation();
        event.preventDefault();
        this.submitted = true;
        if (this.form.valid) {
            this.login.next(this.form.value);
        }
    };
    LoginComponent.prototype.onRegister = function (event) {
        event.preventDefault();
        this.register.next();
    };
    return LoginComponent;
}());
LoginComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'rz-login',
                template: "\n    <form [formGroup]=\"form\" (submit)=\"onSubmit($event)\">\n      <div class=\"card\">\n        <div class=\"row form-group\">\n          <label class=\"col-sm-3 col-form-label\" for=\"username\">Username</label>\n          <div class=\"col\">\n            <input class=\"form-control\" formControlName=\"username\" id=\"username\">\n            <div class=\"md-inputfield\" *ngIf=\"(form.controls.username.touched || submitted) && form.controls.username.errors?.required\">\n              <div class=\"ui-message ui-messages-error ui-corner-all\">\n                Username is required\n              </div>\n            </div>\n          </div>\n        </div>\n        <div class=\"row form-group\">\n          <label class=\"col-sm-3 col-form-label\" for=\"password\">Password</label>\n          <div class=\"col\">\n            <input class=\"form-control\" type=\"password\" formControlName=\"password\" id=\"password\">\n            <div class=\"md-inputfield\" *ngIf=\"(form.controls.password.touched || submitted) && form.controls.password.errors?.required\">\n              <div class=\"ui-message ui-messages-error ui-corner-all\">\n                Password is required\n              </div>\n            </div>\n          </div>\n        </div>\n        <div class=\"row form-group\">\n          <div class=\"offset-sm-3 col\">\n            <button type=\"submit\" pButton label=\"Login\"></button>\n            <a (click)=\"onRegister($event)\">Register</a>\n          </div>\n        </div>\n      </div>\n    </form>\n  "
            },] },
];
/** @nocollapse */
LoginComponent.ctorParameters = function () { return [
    { type: forms_1.FormBuilder, },
]; };
LoginComponent.propDecorators = {
    'login': [{ type: core_1.Output },],
    'register': [{ type: core_1.Output },],
};
exports.LoginComponent = LoginComponent;
