"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var lodash_1 = require("lodash");
var PieComponent = (function () {
    function PieComponent() {
        this.results = [];
        this.scheme = {
            domain: [
                '#2976C2',
                '#20A85B',
                '#FFB300',
                '#FF4548',
                '#844CDA',
                '#2C9AB7',
                '#A0E4CD',
                '#FFD66B',
                '#F37F57',
                '#38545E',
                '#9B4B6D',
                '#FD6A92',
                '#4A4069',
                '#293853',
                '#6C95FF',
                '#45CDCF'
            ]
        };
    }
    PieComponent.prototype.ngOnInit = function () {
        this.update();
    };
    PieComponent.prototype.ngOnChanges = function () {
        this.update();
    };
    PieComponent.prototype.update = function () {
        var _this = this;
        if (this.data && this.categoryProperty && this.valueProperty) {
            var series = this.data.map(function (item) {
                return {
                    name: lodash_1.get(item, _this.categoryProperty),
                    value: lodash_1.get(item, _this.valueProperty)
                };
            });
            this.results = series;
        }
    };
    return PieComponent;
}());
PieComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'rz-pie',
                host: {
                    style: 'display: block; height: 100%'
                },
                template: "<rz-container [title]=\"title\">\n    <div #container style=\"width: 100%; min-height: 200px; height: 100%; overflow: hidden;\">\n      <ngx-charts-pie-chart\n        [view]=\"[container.clientWidth, container.clientHeight]\"\n        [scheme]=\"scheme\"\n        [results]=\"results\"\n        [legend]=\"legend\"\n        [labels]=\"labels\"\n        [doughnut]=\"chartType == 'Donut'\"\n      ></ngx-charts-pie-chart>\n    </div>\n  </rz-container>"
            },] },
];
/** @nocollapse */
PieComponent.ctorParameters = function () { return []; };
PieComponent.propDecorators = {
    'title': [{ type: core_1.Input },],
    'chartType': [{ type: core_1.Input },],
    'data': [{ type: core_1.Input },],
    'categoryProperty': [{ type: core_1.Input },],
    'valueProperty': [{ type: core_1.Input },],
    'legend': [{ type: core_1.Input },],
    'labels': [{ type: core_1.Input },],
};
exports.PieComponent = PieComponent;
