"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var TEXTBOX_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return TextBoxComponent; }),
    multi: true
};
var TextBoxComponent = (function () {
    function TextBoxComponent() {
        this.placeholder = '';
        this.change = new core_1.EventEmitter();
        this.onChange = function (_) { };
        this.onTouched = function () { };
    }
    Object.defineProperty(TextBoxComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value != this.innerValue) {
                this.innerValue = value;
                this.onChange(value);
                this.change.next(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    TextBoxComponent.prototype.writeValue = function (value) {
        this.innerValue = value;
    };
    TextBoxComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    TextBoxComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    return TextBoxComponent;
}());
TextBoxComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'rz-textbox',
                template: "\n    <input\n      type=\"text\"\n      class=\"form-control\"\n      [placeholder]=\"placeholder\"\n      [(ngModel)]=\"value\"\n      (blur)=\"onTouched()\"\n      (change)=\"$event.stopPropagation()\">\n  ",
                providers: [TEXTBOX_VALUE_ACCESSOR]
            },] },
];
/** @nocollapse */
TextBoxComponent.ctorParameters = function () { return []; };
TextBoxComponent.propDecorators = {
    'value': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'change': [{ type: core_1.Output },],
};
exports.TextBoxComponent = TextBoxComponent;
