"use strict";
var http = require('http');
function get(host, path) {
    return new Promise(function (resolve, reject) {
        var options = {
            host: host,
            method: 'GET',
            headers: {
                'Accept': '*/*',
                'User-Agent': 'odata2openapi'
            },
            path: path
        };
        var request = http.request(options, function (response) {
            var result = '';
            response.on('data', function (chunk) {
                result += chunk;
            });
            response.on('end', function () {
                var statusCode = response.statusCode, headers = response.headers;
                if (statusCode >= 300 && statusCode < 400) {
                    get(host, headers['location']).then(resolve, reject);
                }
                else if (statusCode >= 200 && statusCode < 300) {
                    resolve(result);
                }
                else {
                    reject(new Error("Unexpected response: " + response));
                }
            });
        });
        request.on('error', reject);
        request.end();
    });
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = get;
//# sourceMappingURL=get.js.map